%okpeer = ();

$Client_Post_Command_Handler{'hotdesk'}{'qchan'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    my $qchanstring = FOP2::utils::decode_base64($destino);

    # print "qchan origen $origen destino $destino contexto $contexto socket $socket queuechannel string $qchanstring\n";

    my $return  = "";
    
    @partes = split(/\&/,$qchanstring);

    foreach my $elem (@partes) {

        my $profile = "";
        my $queue   = "";
        my $name    = "";
        my $penalty = "";
        my $chan    = "";

        # print "elem $elem\n";

        @pertes = split (/\|/,$elem);
        $chan = $pertes[0];

        foreach my $itm (@pertes) {

            # print "item $itm\n";

            if($itm =~ m/^Profile=(.*)/) {
                $profile = $1;
            }
            if($itm =~ m/^Queue=(.*)/) {
                $queue = $1;
            }
            if($itm =~ m/^MemberName=(.*)/) {
                $name = $1;
            }
            if($itm =~ m/^Penalty=(.*)/) {
                $penalty = $1;
            }
        }

        if($queue eq "") { 
            # Si el perfil no tiene cola, no enviamos queueadd, solo queuelog con cola = nombre de perfil
            $queue = $profile; 
        } else {
            $return  = "Action: QueueAdd\r\n";
            $return .= "Queue: $queue\r\n";
            $return .= "Interface: $chan\r\n";
            $return .= "Penalty: $penalty\r\n";
            $return .= "MemberName: $name\r\n\r\n";
            push @allreturn, $return;
        }

        $return  = "Action: QueueLog\r\n"; 
        $return .= "Queue: $queue\r\n";
        $return .= "Event: ADDMEMBER\r\n";
        $return .= "Interface: $name\r\n\r\n";
        push @allreturn, $return;
    }

    #print Dumper @allreturn;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'xqlogadd'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my ($cola,$name) = split (/~/,$destino);

    # print "origen $origen destino $destino contexto $contexto socket $socket\n";

    my $qchanstring = main::get_btn_config($contexto,$origen,'QUEUECHANNELGET');
    my $profile = "";
    my $chan    = "";

    @partes = split(/\&/,$qchanstring);
    foreach my $elem (@partes) {
        # print "elem $elem\n";
        @pertes = split (/\|/,$elem);
        $chan = $pertes[0];
        foreach my $itm (@pertes) {
            if($itm =~ m/^Profile=(.*)/) {
                $profile = $1;
            }
        }
    }

    $return = "Action: QueueLog\r\n"; 
    $return   .= "Queue: $cola\r\n";
    $return   .= "Event: ADDMEMBER\r\n";
    $return   .= "Interface: $name\r\n\r\n";
    push @allreturn, $return;

    #print Dumper @allreturn;

    return @allreturn;

};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskmap'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    my ($virtual,$real,$channel64) = split(/~/,$destino);
    my $channel = FOP2::utils::decode_base64($channel64);
 
    $return  = "Action: DBPut\r\n";
    $return .= "Family: AMPUSER\r\n";
    $return .= "Key: $virtual/device\r\n";
    $return .= "Val: $real\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    $return  = "Action: DBPut\r\n";
    $return .= "Family: hotdeskmap\r\n";
    $return .= "Key: $channel\r\n";
    $return .= "Val: $virtual\r\n";
    $return .= "\r\n";
    push @allreturn, $return;


    return @allreturn;

};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskprofile'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    my ($profilename,$channel64) = split(/~/,$destino);
    my $channel = FOP2::utils::decode_base64($channel64);

    my $dialprefix = defined($main::pluginconfig{'hotdesk'}{'prefix'}{$profilename})?$main::pluginconfig{'hotdesk'}{'prefix'}{$profilename}:'';

    # print "hotdeskprofile origen $origen, destino $destino, contexto $contexto , socket $socket, profile name $profilename, channel $channel, prefix $dialprefix\n";

    $return  = "Action: DBPut\r\n";
    $return .= "Family: profile\r\n";
    $return .= "Key: $channel\r\n";
    $return .= "Val: $profilename\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    $return  = "Action: DBPut\r\n";
    $return .= "Family: dialprefix\r\n";
    $return .= "Key: $profilename\r\n";
    $return .= "Val: $dialprefix\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskdoverify'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my ($pin,$channel64,$extensionvirtual) = split(/~/,$destino);
    my $channel = FOP2::utils::decode_base64($channel64);

    $return  = "Action: Originate\r\n"; 
    $return .= "Channel: $channel\r\n";
    $return .= "Application: Authenticate\r\n";
    $return .= "Async: 1\r\n";
    $return .= "Data: $pin,a\r\n\r\n";
    push @allreturn, $return;

    # print "seteo la variable hotdesk verify para $channel en valor $pin\n"; 

    $main::pluginvariable{'hotdesk'}{'verify'}{$channel}=$pin . "~" . $extensionvirtual;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'getallowedprofiles'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $channel = main::get_btn_config( "$contexto", $origen, 'MAINCHANNEL');


    $return  = "Action: DBGet\r\n";
    $return .= "Family: HOTDESK/$destino\r\n";
    $return .= "Key: allowed\r\n";
    $return .= "ActionId: getvar!HOTDESK/$destino/allowed!$channel!$contexto\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskpositions'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my @elemento;
    my $ufilter;

    my $peerfilter = defined($main::pluginconfig{'hotdesk'}{'filter'}{''})?$main::pluginconfig{'hotdesk'}{'filter'}{''}:'';
    if($peerfilter ne "") { $ufilter = $peerfilter; $peerfilter = "like $peerfilter"; }
    my $mychannel = main::get_btn_config( "$contexto", $origen, 'MAINCHANNEL');

    # print "origen $origen, destino $destino, contexto $contexto , socket $socket, channel $mychannel, filter ($peerfilter)\n";

    foreach my $final (sort keys %okpeer) {
#        print "(if $final match $ufilter)\n";
        if($final =~ m/^$ufilter/) {
#            print "final $final value ".$okpeer{$final}."\n";
            push @elemento, "{\"e\":\"$final\",\"d\":\"SIP/$final\"}";
        }
    }
#    print "\n";
    
#    my $return = `asterisk -rx "sip show peers $peerfilter" | grep OK`;

#    my @sippeers = split (/\n/,$return);
#    foreach my $linea (@sippeers) { 
#        @partes = split(/ /, $linea);
#        my $final = $partes[0];
#        if($partes[0] =~ m/\//) {
#           @pertes = split(/\//,$partes[0]);
#           $final = $pertes[0];
#        }
#        push @elemento, "{\"e\":\"$final\",\"d\":\"SIP/$final\"}";
#    }

#    $return = `asterisk -rx "iax2 show peers $peerfilter" | grep OK`;
#    my @iaxpeers = split (/\n/,$return);
#    foreach my $linea (@iaxpeers) { 
#        @partes = split(/ /, $linea);
#        my $final = $partes[0];
#        if($partes[0] =~ m/\//) {
#           @pertes = split(/\//,$partes[0]);
#           $final = $pertes[0];
#        }
#        push @elemento, "{\"e\":\"$final\",\"d\":\"SIP/$final\"}";
#    }
 
    $returnjson = " {\"p\":[";
    $returnjson .= join(",",@elemento);
    $returnjson .= "]}";

    my @manual;

    # 15 extensions is a safe bet to avoid having data larger than 1024 bytes
    $size=15;

    for( 0..$#elemento ) {
        my $row = int ($_ / $size);
        $manual[$row]=[] unless exists $manual[$row];
        push @{$manual[$row]}, $elemento[$_];
    }

    for ( 0..$#manual ) {
        $returnjson = "";

        # we append start or end json variables, or both if all of them fit on one event
        $startend="";
        if($#manual == $_) {
            $startend.= ",\"end\":\"1\"";
        }
        if ($_ == 0) {
            $startend.= ",\"start\":\"1\"";
        } 
   
        $returnjson = "{\"p\":[";
        $returnjson .= join(",",@{$manual[$_]});
        $returnjson .= "]$startend}";

        # print $returnjson."\n";

        my $returnjson64 = FOP2::utils::encode_base64($returnjson);

        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: ListPositions\r\n";
        $return .= "Channel: $mychannel\r\n";
        $return .= "Family: hotdeskpositions\r\n";
        $return .= "Value: $returnjson64\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

    }

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'logoff'} = sub {
    my $origen     = shift;
    my $destino    = shift;
    my $contexto   = shift;
    my $socket     = shift;
    my $extension  = shift;
    my @allreturn;
    my $return = '';

    # print "logoff origen $origen destino $destino contexto $contexto socket $socket extension $extension\n";

    my $mainchannel = main::get_btn_config($contexto,$origen,'MAINCHANNEL');

    # print "main channel en logoff $mainchannel\n";

    my $qchanstring = main::get_btn_config($contexto,$origen,'QUEUECHANNELGET');

    # print "qchan string = ($qchanstring)\n";

    if($qchanstring ne "") {

        # print "tenia qchan $qchanstring\n";
        # qchan SIP/603|Penalty=0|MemberName=Nicolas Softphone|Queue=103
        @partes = split(/\&/,$qchanstring);

        foreach my $elem (@partes) {
            # print "elem $elem\n";
            @pertes = split (/\|/,$elem);
            my $chan = $pertes[0];
            my $queue = "";
            my $name = "";
            foreach my $itm (@pertes) {
                if($itm =~ m/^MemberName=(.*)/) {
                    $name = $1;
                }
            }

            $return  = "Action: QueuePause\r\n";
            $return .= "Interface: $chan\r\n";
            $return .= "Paused: 0\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: DBDel\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: $chan\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: DBDel\r\n";
            $return .= "Family: profile\r\n";
            $return .= "Key: $chan\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: DBDel\r\n";
            $return .= "Family: fop2state\r\n";
            $return .= "Key: $mainchannel\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: DBDel\r\n";
            $return .= "Family: hotdeskmap\r\n";
            $return .= "Key: $chan\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: DBPut\r\n";
            $return .= "Family: AMPUSER\r\n";
            $return .= "Key: $destino/device\r\n";
            $return .= "Val: \r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: FOP2ASTDB\r\n";
            $return .= "Channel: $mainchannel\r\n";
            $return .= "Family: fop2state\r\n";
            $return .= "Value: \r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            my @removequeue;
            my @removequeuelog;
            my $profilename;

            foreach my $itm (@pertes) {
                if($itm =~ m/^Profile=(.*)/) {
                    $profilename = $1;
                }
            }

            foreach my $itm (@pertes) {
                if($itm =~ m/^Queue=(.*)/) {
                    $queue = $1;
                    if($queue ne "") {
                        push @removequeue, $queue;
                        push @removequeuelog, $queue;
                    } else {
                        push @removequeuelog, $profilename;
                    }
                }
            }

            foreach my $itm (@removequeue) {
                $return = "Action: QueueRemove\r\n";
                $return .= "Queue: $itm\r\n";
                $return .= "Interface: $chan\r\n\r\n";
                push @allreturn, $return;
                # print "$return\n\n";
            }
 
            foreach my $itm (@removequeuelog) {
                $return = "Action: QueueLog\r\n"; 
                $return.= "Queue: $itm\r\n";
                $return.= "Event: REMOVEMEMBER\r\n";
                $return.= "Interface: $name\r\n\r\n";
                push @allreturn, $return;
                # print "$return\n\n";
            }

        }
    } else {
         # print "no tenia qchanstring\n";
    }
    delete $main::pluginvariable{'hotdesk'}{'mychan'}{$socket};
    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'mychan'} = sub {

    # Interceptamos el mychan para guardar el canal al cual poner pausa y demas con el presence box

    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my ($key,$exten,$data) = split(/~/,$destino);

    # print "hotdesk intercept mychan on server $origen, $destino, $contexto, $socket\n";

    my $channel = FOP2::utils::decode_base64($destino);
    $main::pluginvariable{'hotdesk'}{'mychan'}{$socket} = $channel;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'setastdb'} = sub {
   
    # Interceptamos cambios de presencia para poner en pausa y setear astdb pausecustom para asternic

    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my ($key,$exten,$data) = split(/~/,$destino);

    my $channel = $main::pluginvariable{'hotdesk'}{'mychan'}{$socket};

    # print "setastdb origen $origen, destino $destino ($key,$exten,$data), contexto $contexto, socket $socket, channel de pluginvariable $channel\n";

    if( $data =~ m/^([A-Za-z0-9+\/]{4})*([A-Za-z0-9+\/]{4}|[A-Za-z0-9+\/]{3}=|[A-Za-z0-9+\/]{2}==)$/) {
        $data = FOP2::utils::decode_base64($data);
    }

    if($key eq "fop2state") {
        if($data ne "") {
            my $epoch = time();
            $return  = "Action: DBPut\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: $channel\r\n";
            $return .= "Val: $data:$epoch\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: QueuePause\r\n";
            $return .= "Interface: $channel\r\n";
            $return .= "Paused: 1\r\n";
            $return .= "Reason: $data\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

        } else {
            $return  = "Action: DBDel\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: $channel\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: QueuePause\r\n";
            $return .= "Interface: $channel\r\n";
            $return .= "Paused: 0\r\n";
            $return .= "\r\n";
            push @allreturn, $return;
 
       }
    }
    return @allreturn;
};

$AMI_Event_Handler{'hotdesk'}{'PEERENTRY'} = sub {
    # Para tener la lista de sip peers registrados, y evitar usar asterisk rx
    my $event = shift;
    my @allreturn;
    my $status = ${$event}{'Status'};
    my $obj    = ${$event}{'ObjectName'};
    if($status =~ /OK/) {
        $okpeer{$obj}="ok";
        print "entry peer $obj ok\n";
    }
    #print Dumper \%okpeer;
};

$AMI_Event_Handler{'hotdesk'}{'PEERSTATUS'} = sub {
    # Para tener la lista de sip peers registrados, y evitar usar asterisk rx

    my $event = shift;
    my @allreturn;

    my $obj = ${$event}{Peer};
    my $status = ${$event}{PeerStatus}; 
    $obj =~ s|SIP/||g;
    if($status eq "Registered" || $status eq "Reachable") {
        print "status peer $obj ok\n";
        $okpeer{$obj}="ok";
    } else {
        delete $okpeer{$obj};
        print "status borro peer $obj (status $status)\n";
    }
    #print Dumper \%okpeer;
};

$AMI_Event_Handler{'hotdesk'}{'ORIGINATERESPONSE'} = sub {

    # Guardamos el numero discado de un originate response que tenga canal Local
    # Y vamos a usarlo cuando recibamos un link entre local y sip/real

    my $event = shift;
    my @allreturn;

    $response   = ${$event}{Response};
    $channel    = FOP2::utils::get_channel(${$event}{Channel});

    if($response eq "Success") {
        if($channel =~ /^LOCAL/) {
            $main::pluginvariable{'hotdesk'}{'dialednumber'}{$channel} = ${$event}{Exten};
        }
    }

    return @allreturn;
};

$AMI_Event_Handler{'hotdesk'}{'LINK'} = sub {
    my $event = shift;
    my @allreturn;

    # Interceptamos un LINK para sacar el dialed number guardado en el originate response
    # Y de paso ponemos direccion saliente al canal virtual/custom

    $canal  = FOP2::utils::get_channel(${$event}{Channel1});
    $canal2 = FOP2::utils::get_channel(${$event}{Channel2});

    if ( $canal =~ /^LOCAL/ && $canal2 !~ /^LOCAL/ ) {
        if($canal2 =~ /^VIRTUAL/ || $canal2 =~ /^CUSTOM/) {

            $dialednum = $main::pluginvariable{'hotdesk'}{'dialednumber'}{$canal};

            if($dialednum ne "") {
                $return  = "Action: UserEvent\r\n";
                $return .= "UserEvent: direction\r\n";
                $return .= "Channel: $canal2\r\n";
                $return .= "Family: directionhotdesk\r\n";
                $return .= "Value: outbound\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return  = "Action: UserEvent\r\n";
                $return .= "UserEvent: settext\r\n";
                $return .= "Channel: $canal2\r\n";
                $return .= "Family: settexthotdesk\r\n";
                $return .= "Value: $dialednum\r\n";
                $return .= "\r\n";
                push @allreturn, $return;
 
            }
 
        }
    } else {

    }

    return @allreturn;
};

$AMI_Event_Handler{'hotdesk'}{'NEWACCOUNTCODE'} = sub {
    my $event = shift;
    my @allreturn;

    my @partes = split( /-/, ${$event}{Channel} );
    pop(@partes);
    my $canal = uc( join( "-", @partes ) );

    # print "canal $canal\n";
    # print "event channel ".${$event}{Channel}."\n";

    my $accode = ${$event}{AccountCode};

    if ( defined ( $main::pluginvariable{'hotdesk'}{'verify'}{$canal} ) ) {
        my ($pin,$extensionvirtual) = split(/~/,$main::pluginvariable{'hotdesk'}{'verify'}{$canal});
        if ( $pin eq $accode ) {
            # print "El canal $canal puso bien el pin $accode para canal $newcanal\n";

            my $newcanal = "CUSTOM/".$extensionvirtual;
            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: verified\r\n";
            $return .= "Channel: $newcanal\r\n";
            $return .= "Family: verified\r\n";
            $return .= "Value: $pin\r\n";
            $return .= "\r\n";
            push @allreturn, $return;
 
            $newcanal = "VIRTUAL/".$extensionvirtual;
            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: verified\r\n";
            $return .= "Channel: $newcanal\r\n";
            $return .= "Family: verified\r\n";
            $return .= "Value: $pin\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            delete $main::pluginvariable{'hotdesk'}{'verify'}{$canal};
 
        } else {
            # print "El canal $canal NO NO puso bien el pin $accode\n";
        }
    } else {
        # print "no esta definida la variable de hotdesk verify para $canal\n";
    }

    return @allreturn;
};
